case $CONFIG in
'')
	if test ! -f config.sh; then
		ln ../config.sh . || \
		ln ../../config.sh . || \
		ln ../../../config.sh . || \
		(echo "Can't find config.sh."; exit 1)
	fi 2>/dev/null
	. config.sh
	;;
esac
case "$0" in
*/*) cd `expr X$0 : 'X\(.*\)/'` ;;
esac
echo "Extracting agent/mhook (with variable substitutions)"
$spitshell >mhook <<!GROK!THIS!
# feed this into perl
	eval 'exec perl -S \$0 "\$@"'
		if \$running_under_some_shell;

# You'll need to set up a .forward file that feeds your mail to this script,
# via the filter. Mine looks like this:
#   "|exec /users/ram/mail/filter >>/users/ram/.bak 2>&1"

# $Id: mhook.SH,v 2.9.1.1 92/08/26 12:44:48 ram Exp $
#
#  Copyright (c) 1991, 1992, Raphael Manfredi
#
#  You may redistribute only under the terms of the GNU General Public
#  Licence as specified in the README file that comes with dist.
#
# $Log:	mhook.SH,v $
# Revision 2.9.1.1  92/08/26  12:44:48  ram
# patch8: created
# 

# Perload ON

# The following were determined by Configure
\$mversion = '$VERSION';			# Current version number
\$patchlevel = '$PATCHLEVEL';		# And patchlevel from patchlevel.h
!GROK!THIS!

$spitshell >>mhook <<'!NO!SUBS!'

$prog_name = $0;				# Who I am
$prog_name =~ s|^.*/(.*)|$1|;	# Keep only base name
$has_option = 0;				# True if invoked with options
$config_file = '~/.mailagent';	# Default configuration file

# Parse options
while ($ARGV[0] =~ /^-/) {
	$_ = shift;
	last if /--/;
	if ($_ eq '-h') {
		&usage;
	}
	elsif ($_ eq '-V') {	# Version number
		print STDERR "$prog_name $mversion PL$patchlevel\n";
		exit 0;
	}
	else {
		print STDERR "$prog_name: unknown option: $_\n";
		&usage;
	}
}

$hook_name = shift;				# Where mailhook folder is located
&usage unless $hook_name;		# Hook file is a mandatory argument
$file_name = shift;				# File name to be processed (null if stdin)

$ENV{'IFS'}='' if $ENV{'IFS'};	# Shell separation field
&read_config($config_file);		# Read configuration file and set cf package

$ENV{'HOME'} = $cf'home;
$ENV{'USER'} = $cf'user;
$ENV{'NAME'} = $cf'name;

umask(077);						# Files we create are private ones
$jobnum = &jobnum;				# Compute a job number
&init_all;						# Start-up initializations

$hook_type = &hook_type($hook_name);			# Determine kind of hook
&hooking($file_name, $hook_name, $hook_type);	# Print log message
chdir($cf'home);								# Hook called in home directory
&$hook_type($file_name, $hook_name);			# Invoke hooking function

# End of mailhook processing
&add_log("mailhook exits") if $loglvl > 17;
exit 0;

# Print usage and exit
sub usage {
	print STDERR <<EOF;
Usage: $prog_name [-hV] hook [mail]
  -h : print this help message and exits.
  -V : print version number and exits.
EOF
	exit 1;
}

# Start-up initializations
sub init_all {
	&init_signals;				# Trap common signals
	&init_constants;			# Constants definitions
}

# Protect ourselves (trap common signals)
sub init_signals {
	$SIG{'HUP'} = 'emergency';
	$SIG{'INT'} = 'emergency';
	$SIG{'QUIT'} = 'emergency';
	$SIG{'PIPE'} = 'emergency';
	$SIG{'IO'} = 'emergency';
	$SIG{'BUS'} = 'emergency';
	$SIG{'ILL'} = 'emergency';
	$SIG{'SEGV'} = 'emergency';
	$SIG{'ALRM'} = 'emergency';
	$SIG{'TERM'} = 'emergency';
}

# Constants definitions
sub init_constants {
	&init_hooks;				# Init hooks constants
}

!NO!SUBS!
$grep -v '^;#' pl/jobnum.pl >>mhook
$grep -v '^;#' pl/read_conf.pl >>mhook
$grep -v '^;#' pl/acs_rqst.pl >>mhook
$grep -v '^;#' pl/free_file.pl >>mhook
$grep -v '^;#' pl/add_log.pl >>mhook
$grep -v '^;#' pl/checklock.pl >>mhook
$grep -v '^;#' pl/hook.pl >>mhook
$grep -v '^;#' pl/mailhook.pl >>mhook
$grep -v '^;#' pl/dbr.pl >>mhook
$grep -v '^;#' pl/fatal.pl >>mhook
$grep -v '^;#' pl/parse.pl >>mhook
$grep -v '^;#' pl/header.pl >>mhook
$grep -v '^;#' pl/rfc822.pl >>mhook
$grep -v '^;#' pl/extern.pl >>mhook
chmod 755 mhook
$eunicefix mhook
