;# $Id: acs_rqst.pl,v 2.9 92/07/14 16:49:28 ram Exp $
;#
;#  Copyright (c) 1991, Raphael Manfredi
;#
;#  You may redistribute only under the terms of the GNU General Public
;#  Licence as specified in the README file that comes with dist.
;#
;# $Log:	acs_rqst.pl,v $
;# Revision 2.9  92/07/14  16:49:28  ram
;# 3.0 beta baseline.
;# 
;#
# Asks for the exclusive access of a file
# The given parameter (let's say F) is the absolute path
# of the file we want to access. The routine checks for the
# presence of F.lock. If it exists, it sleeps 1 second and tries
# again. After 10 trys, it reports failure by returning -1.
# Otherwise, file F.lock is created and the pid of the current
# process is written. It is checked afterwards.
sub acs_rqst {
	local($file) = @_;	# file to be locked
	local($max) = 10;	# max number of attempts
	local($mask);		# to save old umask
	while ($max) {
		$max--;
		if (-f "$file.lock") {
			sleep(2);	# busy: wait
			next;
		}
		# Attempt to create lock
		$mask = umask(0333);			# no write permission
		if (open(FILE, ">$file.lock")) {
			print FILE "$$\n";			# write pid
			close FILE;
			umask($mask);				# restore old umask
			# Check lock
			open(FILE, "$file.lock");
			$_ = <FILE>;				# read contents
			close FILE;
			last if int($_) == $$;		# lock is ok
		} else {
			umask($mask);				# restore old umask
			sleep(2);					# busy: wait
		}
	}
	if ($max) {
		$result = 0;	# ok
	} else {
		$result = -1;	# could not lock
	}
	$result;			# return status
}

