;# $Id: add_log.pl,v 2.9 92/07/14 16:49:34 ram Exp $
;#
;#  Copyright (c) 1991, Raphael Manfredi
;#
;#  You may redistribute only under the terms of the GNU General Public
;#  Licence as specified in the README file that comes with dist.
;#
;# $Log:	add_log.pl,v $
;# Revision 2.9  92/07/14  16:49:34  ram
;# 3.0 beta baseline.
;# 
# Add an entry to logfile
# There is no need to lock logfile as print is sandwiched betweeen
# an open and a close (kernel will flush at the end of the file).
sub add_log {
	&write_log;		# Inderection needed, so that we may remap on stderr_log
}

# When mailagent is used interactively, log messages are also printed on
# the standard error.
# NB: this function is not called directly, but via a type glob *add_log.
sub stderr_log {
	print STDERR "$prog_name: $_[0]\n";
	&write_log;
}

# Log message into logfile, using jobnum to identify process.
sub write_log {
	local($date);
	local($log);

	($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) =
		localtime(time);
	$date = sprintf("%.2d/%.2d/%.2d %.2d:%.2d:%.2d",
		$year,++$mon,$mday,$hour,$min,$sec);
	$log = $date . " $prog_name[$jobnum]: $_[0]\n";

	open(LOGFILE, ">>$cf'logfile");
	print LOGFILE $log;
	close LOGFILE;
}

