;# $Id: checklock.pl,v 2.9 92/07/14 16:49:41 ram Exp $
;#
;#  Copyright (c) 1991, Raphael Manfredi
;#
;#  You may redistribute only under the terms of the GNU General Public
;#  Licence as specified in the README file that comes with dist.
;#
;# $Log:	checklock.pl,v $
;# Revision 2.9  92/07/14  16:49:41  ram
;# 3.0 beta baseline.
;# 
;#
;# The $lockext variable must be correctly set.
;#
# Make sure lock lasts for a reasonable time
sub checklock {
	local($file) = shift(@_);				# Full path name
	local($lockfile) = $file . $lockext;	# Add lock extension
	if (-f $lockfile) {
		# There is a lock file -- look for how long it's been there
		($dev,$ino,$mode,$nlink,$uid,$gid,$rdev,$size,
			$atime,$mtime,$ctime,$blksize,$blocks) = stat($lockfile);
		if ((time - $mtime) > 3600) {
			# More than one hour !! Something must have gone wrong
			unlink $lockfile;
			$file =~ s|.*/(.*)|$1|;	# Keep only basename
			do add_log("UNLOCKED $file (lock older than one hour)")
				if ($loglvl > 5);
		}
	}
}

