;# $Id: extern.pl,v 2.9.1.1 92/08/26 13:10:33 ram Exp $
;#
;#  Copyright (c) 1992, Raphael Manfredi
;#
;#  You may redistribute only under the terms of the GNU General Public
;#  Licence as specified in the README file that comes with dist.
;#
;# $Log:	extern.pl,v $
;# Revision 2.9.1.1  92/08/26  13:10:33  ram
;# patch8: created
;# 
;# 
;# External variables are stored in the dbr database. They provide persistent
;# values accross different invocations of the mailagent.
;#
#
# Persitent variables handling
#

package extern;

# Fetch value of a persistent variable
sub val {
	local($name) = @_;
	local($time, $linenum, @value) = &dbr'info($name, 'VARIABLE');
	join("\t", @value);		# TAB is the record separator in dbr
}

# Update value of a persistent variable
sub set {
	local($name, $value) = @_;
	&dbr'update($name, 'VARIABLE', undef, $value);
}

# Fetch age of the variable (elapsed time since last modification)
sub age {
	local($name) = @_;
	local($time, $linenum) = &dbr'info($name, 'VARIABLE');
	time - $time;
}

package main;

