;# $Id: mailhook.pl,v 2.9.1.1 92/08/26 13:16:58 ram Exp $
;#
;#  Copyright (c) 1992, Raphael Manfredi
;#
;#  You may redistribute only under the terms of the GNU General Public
;#  Licence as specified in the README file that comes with dist.
;#
;# $Log:	mailhook.pl,v $
;# Revision 2.9.1.1  92/08/26  13:16:58  ram
;# patch8: created
;# 
;# 
#
# Various hook utilities
# (name in package hook, compiled in package mailhook)
#

package mailhook;

# Parse mail and initialize special variables. The perl script used as hook
# does not have (usually) to do any parsing on the mail. Headers of the mail
# are available via the %header array and some special variables are set as
# conveniences.
sub hook'initialize {
	*header = *main'Header;		# User may fetch headers via %header
	$sender = $header{'Sender'};
	$subject = $header{'Subject'};
	$precedence = $header{'Precedence'};
	$from = $header{'From'};
	$to = $header{'To'};
	$cc = $header{'Cc'};
	($address, $friendly) = &'parse_address($from);
	$login = &'login_name($from);
	@to = split(/,/, $to);
	@cc = split(/,/, $to);
	# Leave only the address part in @to and @cc
	grep(($_ = (&'parse_address($_))[0], 0), @to);
	grep(($_ = (&'parse_address($_))[0], 0), @cc);
}

# Load hook script and run it
sub hook'run {
	local($hook) = @_;
	open(HOOK, $hook) || &'fatal("cannot open $hook: $!");
	local($/) = undef;
	local($body) = <HOOK>;		# Slurp whole file
	close(HOOK);
	unshift(@INC, $'privlib);	# Files first searched for in mailagent's lib
	eval $body;					# Load, compile and execute within mailhook
	if (chop($@)) {
		$@ =~ s/ in file \(eval\)//;
		&'add_log("ERROR $@") if $'loglvl;
		&'fatal("$hook aborted");
	}
}

package main;

