# This MUST be the first test ever run
do '../pl/init.pl';
do '../pl/logfile.pl';
chdir '../out' || exit 0;
chop($pwd = `pwd`);
$path = $ENV{'PATH'};
$host = $ENV{'HOST'};
$user = $ENV{'USER'};
open(CONFIG, ">.mailagent") || print "1\n";
print CONFIG <<EOF;
home     : $pwd
level    : 21			# Undocumented of course
tmpdir   : /tmp
emergdir : $pwd/emerg
track    : OFF
path     : .
p_$host  : .
user     : $user
name     : Mailagent Test Suite
vacation : OFF
vacfile  : ~/.vacation
vacperiod: 1d
spool    : ~
queue    : ~/queue		# This is a good test for comments
logdir   : ~
context  : \$spool/context
log      : agentlog
seq      : .seq
timezone : PST8PDT
statfile : \$spool/mailagent.st
rules    : ~/.rules
maildrop : $pwd			# Do not LEAVE messages in /usr/spool/mail
mailbox  : \$user		# Use config variable, not current perl $user
hash     : dbr
cleanlaps: 1M
autoclean: OFF
agemax   : 1y
comfile  : \$spool/commands
distlist : \$spool/distribs
proglist : \$spool/proglist
maxsize  : 150000
plsave   : \$spool/plsave
authfile : \$spool/auth
EOF
close CONFIG;
`rm -rf queue emerg`;
`mkdir emerg`;
$? == 0 || print "2\n";
# Use the special undocumented -t option from filter to get HOME directory
# via environment instead of /etc/passwd.
open(FILTER, "|$filter -t >/dev/null 2>&1") || print "3\n";
print FILTER <<EOF;
Dummy mail
EOF
close FILTER;
$? != 0 || print "4\n";			# No valid queue directory
$file = <emerg/*>;
if (-f "$file") {
	open(FILE, $file) || print "5\n";
	@file = <FILE>;
	close FILE;
	$file[0] eq "Dummy mail\n" || print "6\n";
	unlink "$file";
} else {
	print "5\n";				# No emergency dump
}
-s 'agentlog' || print "6\n";	# No logfile or empty
&get_log(7);
&check_log('FATAL', 8);				# There must be a FATAL
&check_log('MTA', 9);				# Filter must think mail is in MTA's queue
&check_log('updating PATH', 10);	# Make sure hostname is computed
&check_log('unable to queue', 11);	# Filter did not queue mail
unlink 'agentlog';
`mkdir queue`;
$? == 0 || print "12\n";		# Cannot make queue
print "0\n";
