# Make sure filter queues messages correctly
do '../pl/init.pl';
do '../pl/logfile.pl';
chdir '../out' || exit 0;
open(WAIT, ">queue/agent.wait") || print "1\n";
close WAIT;
`chmod u-w queue`;
$? == 0 || print "2\n";
# Use the special undocumented -t option from filter to get HOME directory
# via environment instead of /etc/passwd.
open(FILTER, "|$filter -t >/dev/null 2>&1") || print "3\n";
print FILTER <<EOF;
Dummy mail
EOF
close FILTER;
$? == 0 || print "4\n";		# Must terminate correctly (stored in agent.wait)
&get_log(5);
&check_log('memorized', 6);	# Make sure mail has been memorized
-s 'queue/agent.wait' || print "7\n";
$file = <emerg/*>;
if (-f "$file") {
	chop($what = `cat queue/agent.wait`);
	chop($pwd = `pwd`);
	$what eq "$pwd/$file" || print "8\n";
	unlink "$file";
} else {
	print "8\n";
}
`chmod u+w queue`;
unlink 'queue/agent.wait', 'agentlog';
open(FILTER, "|$filter -t >/dev/null 2>&1") || print "9\n";
print FILTER <<EOF;
Dummy mail
EOF
close FILTER;
$? == 0 || print "10\n";	# Must terminate correctly (queued)
&get_log(11);
&check_log('QUEUED', 12);	# Mail was queued
$file = <queue/qm*>;
-f "$file" || print "13\n";	# Must have been left in queue
unlink "$file", 'agentlog';
# Make sure file is correctly queued when another filter is running
`cp /dev/null filter.lock`;
$? == 0 || print "14\n";
open(FILTER, "|$filter -t >/dev/null 2>&1") || print "15\n";
print FILTER <<EOF;
Dummy mail
EOF
close FILTER;
$? == 0 || print "16\n";	# Must terminate correctly (queued)
&get_log(17);
&check_log('QUEUED', 18);	# Mail was queued
$file = <queue/fm*>;
-f "$file" || print "19\n";	# Must have been left in queue as a 'fm' file
unlink "$file", 'agentlog', 'filter.lock';
print "0\n";
